/*
 * cross-platform macros
 */
#ifndef _Q9XX_PLATFORM_H_
#define _Q9XX_PLATFORM_H_

#if defined(Q931_PRIVATE) || defined(Q921_PRIVATE)
/*
 * Private view
 */

/*
 * Win32 MSVC
 */
#if defined(_MSC_VER)
#pragma warning(disable:4100)
#ifndef __inline__
#define __inline__ __inline
#endif
#if (_MSC_VER >= 1400)			/* VC8+ */
#ifndef _CRT_SECURE_NO_DEPRECATE
#define _CRT_SECURE_NO_DEPRECATE
#endif
#ifndef _CRT_NONSTDC_NO_DEPRECATE
#define _CRT_NONSTDC_NO_DEPRECATE
#endif
#endif /* _MSC_VER >= 1400 */
#ifndef strcasecmp
#define strcasecmp(s1, s2) _stricmp(s1, s2)
#endif
#ifndef strncasecmp
#define strncasecmp(s1, s2, n) _strnicmp(s1, s2, n)
#endif
#ifndef snprintf
#define snprintf _snprintf
#endif
#define PLATFORM_WIN32 1
#endif /* _MSC_VER */

#if defined(PLATFORM_WIN32)
#if !defined(HAVE_RANDOM)
#define random rand
#endif
#endif

/*
 * Compiler specific
 */
#if defined(__GNUC__)
#define Q921_API	__attribute__((visibility("default")))
#define Q931_API	__attribute__((visibility("default")))

#elif defined(__SUNPRO_C) || defined(__SUNPRO_CC)
#define Q921_API	__attribute__((visibility("default")))
#define Q931_API	__attribute__((visibility("default")))

#elif defined(_MSC_VER)
#define Q921_API	__declspec(dllexport) __stdcall
#define Q931_API	__declspec(dllexport) __stdcall

#else
#define Q921_API
#define Q931_API
#endif

#else	/* !Q931_PRIVATE */
/*
 * Public view
 */
#define Q921_API
#define Q931_API

#endif
#endif
